Index: trunk/src/civ.m
===================================================================
--- trunk/src/civ.m	(revision 382)
+++ trunk/src/civ.m	(revision 384)
@@ -23,5 +23,5 @@
 %TODO: search range
 
-% Last Modified by GUIDE v2.5 27-Jan-2012 00:32:33
+% Last Modified by GUIDE v2.5 10-Mar-2012 22:32:10
 % Begin initialization code - DO NOT EDIT
 gui_Singleton = 1;
@@ -281,4 +281,5 @@
 end
 set(handles.RootPath,'BackgroundColor',[1 1 1])%paint RootName back to white to indicate that the file input is finished
+
 %------------------------------------------------------------------------
 % --- general function activated for an input file series
@@ -1035,5 +1036,5 @@
 %could be included in get_mask callback ?
 if isequal(get(handles.CheckMask,'Value'),1)
-    maskname=get(handles.txt_Mask,'String');
+    maskname=get(handles.Mask,'String');
     if ~exist(maskname,'file')
         get_mask_civ1_Callback(hObject, eventdata, handles);
@@ -1041,5 +1042,5 @@
 end
 if isequal(get(handles.CheckMask,'Value'),1)
-    maskname=get(handles.txt_Mask,'String');
+    maskname=get(handles.Mask,'String');
     if ~exist(maskname,'file')
         get_mask_fix1_Callback(hObject, eventdata, handles);
@@ -1047,5 +1048,5 @@
 end
 if isequal(get(handles.CheckMask,'Value'),1)
-    maskname=get(handles.txt_Mask,'String');
+    maskname=get(handles.Mask,'String');
     if ~exist(maskname,'file')
         get_mask_civ2_Callback(hObject, eventdata, handles);
@@ -1053,5 +1054,5 @@
 end
 if isequal(get(handles.CheckMask,'Value'),1)
-    maskname=get(handles.txt_Mask,'String');
+    maskname=get(handles.Mask,'String');
     if ~exist(maskname,'file')
         get_mask_fix2_Callback(hObject, eventdata, handles);
@@ -3310,5 +3311,5 @@
 maskval=get(handles.CheckMask,'Value');
 if isequal(maskval,0)
-    set(handles.txt_Mask,'String','')
+    set(handles.Mask,'String','')
 else
     mask_displ='no mask'; %default
@@ -3343,7 +3344,7 @@
         set(handles.CheckMask,'Value',1)
     end
-    set(handles.txt_Mask,'String',mask_displ)
-    set(handles.txt_Mask,'String',mask_displ)
-    set(handles.txt_Mask,'String',mask_displ)
+    set(handles.Mask,'String',mask_displ)
+    set(handles.Mask,'String',mask_displ)
+    set(handles.Mask,'String',mask_displ)
 end
 
@@ -3354,5 +3355,5 @@
 maskval=get(handles.CheckMask,'Value');
 if isequal(maskval,0)
-    set(handles.txt_Mask,'String','')
+    set(handles.Mask,'String','')
 else
     mask_displ='no mask'; %default
@@ -3385,6 +3386,6 @@
         set(handles.CheckMask,'Value',1)
     end
-    set(handles.txt_Mask,'String',mask_displ)
-    set(handles.txt_Mask,'String',mask_displ)
+    set(handles.Mask,'String',mask_displ)
+    set(handles.Mask,'String',mask_displ)
 end
 
@@ -3395,5 +3396,5 @@
 maskval=get(handles.CheckMask,'Value');
 if isequal(maskval,0)
-    set(handles.txt_Mask,'String','')
+    set(handles.Mask,'String','')
 else
     mask_displ='no mask'; %default
@@ -3423,5 +3424,5 @@
         set(handles.CheckMask,'Value',0)
     end
-    set(handles.txt_Mask,'String',mask_displ)
+    set(handles.Mask,'String',mask_displ)
 end
 
@@ -3676,6 +3677,6 @@
 %     stage=4;%default
     if strcmp(parent_tag,'Civ1')
-            set(handles.txt_Mask,'Visible','on')
-        set(handles.txt_Mask,'String',filemask)
+            set(handles.Mask,'Visible','on')
+        set(handles.Mask,'String',filemask)
     set(handles.CheckMask,'Value',1)
     end
@@ -3688,6 +3689,6 @@
 % %             stage=4;
 %     end
-%     set(handles.txt_Mask(stage:end),'Visible','on')
-%     set(handles.txt_Mask(stage:end),'String',filemask)
+%     set(handles.Mask(stage:end),'Visible','on')
+%     set(handles.Mask(stage:end),'String',filemask)
 %     set(handles.CheckMask(stage:end),'Value',1)
 else
@@ -4380,5 +4381,17 @@
 
 function NomType_Callback(hObject, eventdata, handles)
-
+set(handles.RootPath,'BackgroundColor',[1 1 0])%paint RootName edit box in yellow to indicate that the file input is proceeding
+RootPath=get(handles.RootPath,'String');
+RootFile=get(handles.RootFile,'String');
+ref_i=str2num(get(handles.ref_i,'String'));
+ref_j=str2num(get(handles.ref_j,'String'));
+NomType=get(handles.NomType,'String');
+ImaExt=get(handles.ImaExt,'String');
+fileinput=fullfile_uvmat(RootPath,'',RootFile,ImaExt,NomType,ref_i,[],ref_j);
+errormsg=display_file_name(handles,fileinput);
+if ~isempty(errormsg)
+    msgbox_uvmat('ERROR',errormsg)
+end
+set(handles.RootPath,'BackgroundColor',[1 1 1])%paint RootName back to white to indicate that the file input is finished
 
 % --- Executes on selection change in ListProgram.