Index: /trunk/src/civ.m
===================================================================
--- /trunk/src/civ.m	(revision 385)
+++ /trunk/src/civ.m	(revision 386)
@@ -2425,8 +2425,7 @@
     movieobject1=[];%default
     if strcmpi(ext_ima,'.avi')
-        hhh=which('mmreader');
-        if ~isequal(hhh,'')&& mmreader.isPlatformSupported()% if the mmreader function is found (recent version of matlab)
+        if ~isempty(which('mmreader'))% if the mmreader function is found (recent version of matlab)
             type_ima1='movie';
-            movieobject1=mmreader([filebase_ima2 ext_ima]);
+            movieobject1=mmreader([filecell.filebase ext_ima]);
         else
             type_ima1='avi';
@@ -2445,8 +2444,7 @@
     movieobject2=[];
     if strcmpi(ext_ima,'.avi')
-        hhh=which('mmreader');
-        if ~isequal(hhh,'')&& mmreader.isPlatformSupported()% if the mmreader function is found (recent version of matlab)
+        if ~isempty(which('mmreader'))% if the mmreader function is found (recent version of matlab)
             type_ima2='movie';
-            movieobject2=mmreader([filebase_ima2 ext_ima]);
+            movieobject2=mmreader([filecell.filebase ext_ima]);
         else
             type_ima2='avi';
Index: /trunk/src/civ_matlab.m
===================================================================
--- /trunk/src/civ_matlab.m	(revision 385)
+++ /trunk/src/civ_matlab.m	(revision 386)
@@ -59,16 +59,16 @@
             if ischar(par_civ1.ImageB)
                 temp=par_civ1.ImageA;
-                par_civ1.ImageA=imread(par_civ1.ImageB);
+                par_civ1.ImageA=sum(imread(par_civ1.ImageB),3);
             end
             if ischar(temp)
-                par_civ1.ImageB=imread(temp);
+                par_civ1.ImageB=sum(imread(temp),3);
             end
         end
     else
         if ischar(par_civ1.ImageA)
-            par_civ1.ImageA=imread(par_civ1.ImageA);
+            par_civ1.ImageA=sum(imread(par_civ1.ImageA),3);
         end
         if ischar(par_civ1.ImageB)
-            par_civ1.ImageB=imread(par_civ1.ImageB);
+            par_civ1.ImageB=sum(imread(par_civ1.ImageB),3);
         end
     end
Index: /trunk/src/find_file_series.m
===================================================================
--- /trunk/src/find_file_series.m	(revision 385)
+++ /trunk/src/find_file_series.m	(revision 386)
@@ -51,4 +51,5 @@
 j1_series=zeros(1,1,1);
 j2_series=zeros(1,1,1);
+% ifile_min=1;%default
 [FileType,FileInfo,Object]=get_file_type(fullfileinput);
 if strcmp( FileType,'multimage')||strcmp( FileType,'video')
@@ -233,10 +234,11 @@
         NomType=regexprep(NomType,['^' NomTypePref],'');
     end
-end
-
-%% update the file type if the input file does not exist (pb of 0001)
-if isempty(FileType)
-    [FileType,tild,Object]=get_file_type(dirpair(ifile_min).name);
-end
+    %% update the file type if the input file does not exist (pb of 0001)
+    if isempty(FileType)
+        [FileType,tild,Object]=get_file_type(dirpair(ifile_min).name);
+    end
+end
+
+
 
 %% set to empty array the irrelevant index series
Index: /trunk/src/get_file_type.m
===================================================================
--- /trunk/src/get_file_type.m	(revision 385)
+++ /trunk/src/get_file_type.m	(revision 386)
@@ -36,37 +36,44 @@
             end
         else
+            error_nc=0;
             try
                 Data=nc2struct(fileinput,'ListGlobalAttribute','absolut_time_T0','Conventions',...
                     'CivStage','patch2','fix2','civ2','patch','fix');
-                if ~isempty(Data.absolut_time_T0')
-                    FileType='civx'; % test for civx velocity fields
-                    if ~isempty(Data.patch2) && isequal(Data.patch2,1)
-                        FileInfo.CivStage=6;
-                    elseif ~isempty(Data.fix2) && isequal(Data.fix2,1)
-                        FileInfo.CivStage=5;
-                    elseif ~isempty(Data.civ2) && isequal(Data.civ2,1);
-                        FileInfo.CivStage=4;
-                    elseif ~isempty(Data.patch) && isequal(Data.patch,1);
-                        FileInfo.CivStage=3;
-                    elseif ~isempty(Data.fix) && isequal(Data.fix,1);
-                        FileInfo.CivStage=2;
-                    elseif ~isempty(Data.absolut_time_T0) && ~isempty(Data.hart)
-                        FileInfo.CivStage=1;
+                if ~isempty(Data.Txt)
+                    error_nc=1;
+                else
+                    if ~isempty(Data.absolut_time_T0')
+                        FileType='civx'; % test for civx velocity fields
+                        if ~isempty(Data.patch2) && isequal(Data.patch2,1)
+                            FileInfo.CivStage=6;
+                        elseif ~isempty(Data.fix2) && isequal(Data.fix2,1)
+                            FileInfo.CivStage=5;
+                        elseif ~isempty(Data.civ2) && isequal(Data.civ2,1);
+                            FileInfo.CivStage=4;
+                        elseif ~isempty(Data.patch) && isequal(Data.patch,1);
+                            FileInfo.CivStage=3;
+                        elseif ~isempty(Data.fix) && isequal(Data.fix,1);
+                            FileInfo.CivStage=2;
+                        elseif ~isempty(Data.absolut_time_T0) && ~isempty(Data.hart)
+                            FileInfo.CivStage=1;
+                        end
+                    elseif strcmp(Data.Conventions,'uvmat/civdata')
+                        FileType='civdata'; % test for civx velocity fields
+                        FileInfo.CivStage=Data.CivStage;
+                    else
+                        FileType='netcdf';
                     end
-                elseif strcmp(Data.Conventions,'uvmat/civdata')
-                    FileType='civdata'; % test for civx velocity fields
-                    FileInfo.CivStage=Data.CivStage;
-                else
-                    FileType='netcdf';
                 end
+            catch ME
+                error_nc=1;
             end
-            try
-                if exist('VideoReader','file')%recent version of Matlab
-                    Object=VideoReader(fullfileinput);
-                else
-                    Object=mmreader(fullfileinput);%older Matlab function for movies
-                end
-                FileType='video';
-                FileInfo.NbFrame=get(Object,'NumberOfFrames');
+            if error_nc
+                    if exist('VideoReader','file')%recent version of Matlab
+                        Object=VideoReader(fileinput);
+                    else
+                        Object=mmreader(fileinput);%older Matlab function for movies
+                    end
+                    FileType='video';
+                    FileInfo.NbFrame=get(Object,'NumberOfFrames');
             end
         end
Index: /trunk/src/uvmat.m
===================================================================
--- /trunk/src/uvmat.m	(revision 385)
+++ /trunk/src/uvmat.m	(revision 386)
@@ -47,6 +47,6 @@
 %           .FieldName_1:(char string) second field selected('image', 'velocity'...)
 %           .CName: (char string)name of the scalar used for vector colors
-%          .MovieObject: movie object representing an input movie
-%          .MovieObject_1: idem for a second input series (_1)
+%          .MovieObject{1}: movie object representing an input movie
+%          .MovieObject{2}: idem for a second input series (_1)
 %          .filename_1 : last second input file name (to deal with a constant second input without reading again the file)
 %          .VelType_1: last velocity type (VelType, civ2...) for the second input series
@@ -1568,6 +1568,9 @@
 NomType=get(handles.NomType,'String');
 i1=str2num(get(handles.i1,'String'));%read the field indices (for movie, it is not given by the file name)
-i2=str2num(get(handles.i2,'String'));
-j1=1;
+i2=[];%default
+if strcmp(get(handles.i2,'Visible'),'on')
+    i2=str2num(get(handles.i2,'String'));
+end
+j1=[];
 if strcmp(get(handles.j1,'Visible'),'on')
     j1=stra2num(get(handles.j1,'String'));
@@ -1592,5 +1595,5 @@
     set(handles.CheckFixPair,'Value',0)
 end
-CheckFixPair=get(handles.CheckFixPair,'Value');
+CheckFixPair=get(handles.CheckFixPair,'Value')||(isempty(i2)&&isempty(j2));
 if CheckFixPair
     if get(handles.scan_i,'Value')==1% case of scanning along index i
@@ -2000,6 +2003,5 @@
                 ParamIn.Npy=UvData.XmlData.Npy;
                 ParamIn.Npx=UvData.XmlData.Npx;
-            else
-                
+            else            
                 errormsg='Npx and Npy need to be defined in the xml file for volume images .vol';
                 return