Index: trunk/sys-description.sample.txt
===================================================================
--- trunk/sys-description.sample.txt	(revision 391)
+++ trunk/sys-description.sample.txt	(revision 392)
@@ -1,74 +1,104 @@
 # From https://github.com/mtoshi/sysdescrparser/blob/master/samples/sample_data.json
 
-Arista Networks EOS version 4.12.7.1 running on an Arista Networks DCS-7150S-24
-Arista Networks EOS version 4.6.0 running on an Arista Networks DCS-7124S
-Arista Networks EOS version 4.14.2F running on an Arista Networks DCS-7504
+A10:
+ - AX Series Advanced Traffic Manager AX1000, Advanced Core OS (ACOS) version 2.4.3-p6,
+ - AX Series Advanced Traffic Manager AX1000, Advanced Core OS (ACOS) version 2.2.4-p8,
 
-Brocade Communications Systems, Inc. FESX624+2XG, IronWare Version 07.3.00cT3e1 Compiled on Apr 25 2012 at 17:01:00 labeled as SXS07300c
-Brocade NetIron CES, IronWare Version V5.2.0cT183 Compiled on Oct 28 2011 at 02:58:44 labeled as V5.2.00c
-Brocade NetIron MLX (System Mode: MLX), IronWare Version V5.4.0cT163 Compiled on Mar 25 2013 at 17:08:16 labeled as V5.4.00c
-Brocade Backbone (System Mode: MLX), IronWare Version V5.1.0dT163 Compiled on Aug 19 2011 at 19:00:39 labeled as V5.1.00d
-Brocade MLXe (System Mode: MLX), IronWare Version V5.3.0T163 Compiled on Jan  3 2012 at 18:01:00 labeled as V5.3.00b460
-Brocade Communications Systems, Inc. ServerIron ADX 1008-1-PREM, TrafficWork Version 12.4.00T401
-Brocade Communications Systems, Inc. ServerIron ADX 4000, TrafficWork Version 12.3.01T403
+ARISTA:
+ - Arista Networks EOS version 4.12.7.1 running on an Arista Networks DCS-7150S-24
+ - Arista Networks EOS version 4.6.0 running on an Arista Networks DCS-7124S
+ - Arista Networks EOS version 4.14.2F running on an Arista Networks DCS-7504
 
-Cisco Internetwork Operating System Software ..IOS (tm) C1700 Software (C1700-Y-M), Version 12.2(4)YB, EARLY DEPLOYMENT RELEASE SOFTWARE (fc1)..Synched to technology version 12.2(6.8)T2..TAC Support: http://www.cisco.com/tac..Copyright (c) 1986-2002 by ci
-Cisco Internetwork Operating System Software ..IOS (tm) C2600 Software (C2600-I-M), Version 12.0(3)T3,  RELEASE SOFTWARE (fc1)..Copyright (c) 1986-1999 by cisco Systems, Inc...Compiled Thu 15-Apr-99 15:41 by kpma
-Cisco IOS Software, C1700 Software (C1700-ADVSECURITYK9-M), Version 12.3(11)YZ2, RELEASE SOFTWARE (fc2)..Technical Support: http://www.cisco.com/techsupport..Copyright (c) 1986-2007 by Cisco Systems, Inc...Compiled Wed 08-Aug-07 19:22 by dchih
-Cisco IOS Software, c7600s72033_rp Software (c7600s72033_rp-ADVIPSERVICESK9-M), Version 12.2(33)SRC5, RELEASE SOFTWARE (fc2)
-Cisco IOS Software, Catalyst 4500 L3 Switch Software (cat4500e-ENTSERVICESK9-M), Version 12.2(50)SG3, RELEASE SOFTWARE (fc2)
-Cisco NX-OS(tm) cgr1000, Software (cgr1000-uk9), Version 5.2(1)CG2(1), Interim version 5.2(1)CG2(0.167), RELEASE SOFTWARE Copyright (c) 2002-2011 by Cisco Systems, Inc. Compiled 1/1/2012 1:00:00
-Cisco NX-OS(tm) m9100, Software (m9100-s2ek9-mz), Version 4.1(1c), RELEASE SOFTWARE Copyright (c) 2002-2008 by Cisco Systems, Inc. Compiled 11/24/2008 18:00:00
-Cisco NX-OS(tm) n3000, Software (n3000-uk9), Version 5.0(3)U1(2), Interim version 5.0(3)U1(1.319), RELEASE SOFTWARE Copyright (c) 2002-2011 by Cisco Systems, Inc. Device Manager Version 5.2(1), Compiled 7/10/2011 6:00:00
-Cisco NX-OS(tm) n5000, Software (n5000-uk9), Version 4.1(3)N1(1a), RELEASE SOFTWARE Copyright (c) 2002-2008 by Cisco Systems, Inc. Device Manager Version 4.2(1), Compiled 9/17/2009 19:00:00
-Cisco IOS XR Software (Cisco ASR9K Series), Version 4.2.3[Default] Copyright (c) 2013 by Cisco Systems, Inc.
-Cisco IOS XR Software (Cisco 12816/PRP), Version 4.3.2[Default] Copyright (c) 2014 by Cisco Systems, Inc.
-Cisco IOS XR Software (Cisco 12404/PRP), Version 3.6.0[00] Copyright (c) 2007 by Cisco Systems, Inc.
+BROCADE:
+ - Brocade Communications Systems, Inc. FESX624+2XG, IronWare Version 07.3.00cT3e1 Compiled on Apr 25 2012 at 17:01:00 labeled as SXS07300c
+ - Brocade NetIron CES, IronWare Version V5.2.0cT183 Compiled on Oct 28 2011 at 02:58:44 labeled as V5.2.00c
+ - Brocade NetIron MLX (System Mode: MLX), IronWare Version V5.4.0cT163 Compiled on Mar 25 2013 at 17:08:16 labeled as V5.4.00c
+ - Brocade Backbone (System Mode: MLX), IronWare Version V5.1.0dT163 Compiled on Aug 19 2011 at 19:00:39 labeled as V5.1.00d
+ - Brocade MLXe (System Mode: MLX), IronWare Version V5.3.0T163 Compiled on Jan  3 2012 at 18:01:00 labeled as V5.3.00b460
+ - Brocade Communications Systems, Inc. ServerIron ADX 1008-1-PREM, TrafficWork Version 12.4.00T401
+ - Brocade Communications Systems, Inc. ServerIron ADX 4000, TrafficWork Version 12.3.01T403
 
-ExtremeXOS version 12.0.3.16 v1203b16 by release-manager on Tue Apr 8 01:08:39 PDT 2008
-ExtremeWare X0S version 11.2.0.15 v1120b15 by release-manager on Fri Apr 1 18:40:23 PST 2005
-ExtremeXOS version 12.1.4.2 v1214b2 by release-manager on Wed Dec 9 13:32:31 PST 2009
-ExtremeXOS version 11.6.3.5 v1163b5 by release-manager on Sun Sep 9 10:46:16 PDT 2007
+CISCO:
+ - Cisco Internetwork Operating System Software ..IOS (tm) C1700 Software (C1700-Y-M), Version 12.2(4)YB, EARLY DEPLOYMENT RELEASE SOFTWARE (fc1)..Synched to technology version 12.2(6.8)T2..TAC Support: http://www.cisco.com/tac..Copyright (c) 1986-2002 by ci
+ - Cisco Internetwork Operating System Software ..IOS (tm) C2600 Software (C2600-I-M), Version 12.0(3)T3,  RELEASE SOFTWARE (fc1)..Copyright (c) 1986-1999 by cisco Systems, Inc...Compiled Thu 15-Apr-99 15:41 by kpma
+ - Cisco IOS Software, C1700 Software (C1700-ADVSECURITYK9-M), Version 12.3(11)YZ2, RELEASE SOFTWARE (fc2)..Technical Support: http://www.cisco.com/techsupport..Copyright (c) 1986-2007 by Cisco Systems, Inc...Compiled Wed 08-Aug-07 19:22 by dchih
+ - Cisco IOS Software, c7600s72033_rp Software (c7600s72033_rp-ADVIPSERVICESK9-M), Version 12.2(33)SRC5, RELEASE SOFTWARE (fc2)
+ - Cisco IOS Software, Catalyst 4500 L3 Switch Software (cat4500e-ENTSERVICESK9-M), Version 12.2(50)SG3, RELEASE SOFTWARE (fc2)
+ - Cisco NX-OS(tm) cgr1000, Software (cgr1000-uk9), Version 5.2(1)CG2(1), Interim version 5.2(1)CG2(0.167), RELEASE SOFTWARE Copyright (c) 2002-2011 by Cisco Systems, Inc. Compiled 1/1/2012 1:00:00
+ - Cisco NX-OS(tm) m9100, Software (m9100-s2ek9-mz), Version 4.1(1c), RELEASE SOFTWARE Copyright (c) 2002-2008 by Cisco Systems, Inc. Compiled 11/24/2008 18:00:00
+ - Cisco NX-OS(tm) n3000, Software (n3000-uk9), Version 5.0(3)U1(2), Interim version 5.0(3)U1(1.319), RELEASE SOFTWARE Copyright (c) 2002-2011 by Cisco Systems, Inc. Device Manager Version 5.2(1), Compiled 7/10/2011 6:00:00
+ - Cisco NX-OS(tm) n5000, Software (n5000-uk9), Version 4.1(3)N1(1a), RELEASE SOFTWARE Copyright (c) 2002-2008 by Cisco Systems, Inc. Device Manager Version 4.2(1), Compiled 9/17/2009 19:00:00
+ - Cisco IOS XR Software (Cisco ASR9K Series), Version 4.2.3[Default] Copyright (c) 2013 by Cisco Systems, Inc.
+ - Cisco IOS XR Software (Cisco 12816/PRP), Version 4.3.2[Default] Copyright (c) 2014 by Cisco Systems, Inc.
+ - Cisco IOS XR Software (Cisco 12404/PRP), Version 3.6.0[00] Copyright (c) 2007 by Cisco Systems, Inc.
 
-Foundry Networks, Inc. Backbone, IronWare Version 06.6.36T41 Compiled on Jul 20 2001 at 21:38:29 labeled as BIS06636
-Foundry Networks, Inc. BigIron 15000 Router, IronWare Version 08.0.01vT53 Compiled on Feb 26 2010 at 20:07:21 labeled as B2P08001v
-Foundry Networks, Inc. BigIron MG8, IronWare Version V2.1.0bT103 Compiled on Apr 23 2005 at 13:32:29 labeled as V2.1.00b
-Foundry Networks, Inc. BigIron RX, IronWare Version V2.7.2mT143 Compiled on Apr 03 2012 at 19:38:35 labeled as V2.7.02m
-Foundry Networks, Inc. FES9604, IronWare Version 04.0.00Tc1 Compiled on Dec 18 2007 at 11:24:02 labeled as FEL04000
-Foundry Networks, Inc. FESX424HF-PREM, IronWare Version 04.3.00T3e3 Compiled on Nov 14 2008 at 15:23:55 labeled as SXR04300
-Foundry Networks, Inc. NetIron 800 Router, IronWare Version 08.0.01vT53 Compiled on Feb 26 2010 at 20:07:21 labeled as B2P08001v
-Foundry Networks, Inc. NetIron CES, IronWare Version V3.9.0T183 Compiled on Jul 23 2009 at 14:18:43 labeled as V3.9.00
+CITRIX:
+ - NetScaler NS9.0: Build 69.5, Date: Jun 12 2009, 06:00:53
+ - NetScaler NS9.1: Build 97.3.cl, Date: Aug 19 2009, 13:03:59
 
-HP J4813A ProCurve Switch 2524, revision F.05.34, ROM F.02.01  (/sw/code/build/info(s02))
-HP J4813A ProCurve Switch 2524, revision F.05.34, ROM F.02.01  (/sw/code/build/info(s02))
-HP J4121A ProCurve Switch 4000M, revision C.09.28, ROM C.06.01 (/sw/code/build/vgro(c09))
-ProCurve J4900B Switch 2626, revision H.08.98, ROM H.08.02 (/sw/code/build/fish(ts_08_5))
-ProCurve J9145A 2910al-24G Switch, revision W.14.03, ROM W.14.04 (/sw/code/build/sbm(t4a_RC3))
-HPJ3298A HP ProCurve Switch 212M, revision D.05.04, ROM D.05.01 (/sw/code/build/srao(f98))
-HP J9625A E2620-24-PoEP Switch, revision RA.15.05.0006, ROM RA.15.10 (/sw/code/build/xform(RA_15_05)) (Formerly ProCurve)
-HP J8692A Switch E3500yl-24G, revision K.15.05.0002, ROM K.15.13 (/sw/code/build/btm(K_15_05)) (Formerly ProCurve)
+DELL:
+ - Dell Networking N2048, 6.2.0.5, Linux 3.6.5-1289203e
+ - Dell Networking N4032F, 6.1.1.7, Linux 2.6.32.9
+ - Dell Networking N4064F, 6.3.1.13, Linux 3.7.10-20383c08
+ - PowerConnect 7024, 5.1.10.1, VxWorks 6.6
 
-Juniper Networks, Inc. ex2200-24t-4g internet router, kernel JUNOS 10.2R1.8 #0: 2010-05-27 20:13:49 UTC
-Juniper Networks, Inc. ex2200-48t-4g internet router, kernel JUNOS 10.2R1.8 #0: 2010-05-27 20:13:49 UTC
-Juniper Networks, Inc. ex2200-c-12t-2g internet router, kernel JUNOS 11.3R1.7 #0: 2011-08-30 11:49:21 UTC
-Juniper Networks, Inc. ex3200-24p internet router, kernel JUNOS 11.1R3.5 #0: 2011-06-25 01:18:46 UTC
-Juniper Networks, Inc. ex4200-24f internet router, kernel JUNOS 10.0S1.1 #0: 2010-01-08 06:28:28 UTC
-Juniper Networks, Inc. ex4200-24t internet router, kernel JUNOS 10.2R1.8 #0: 2010-05-27 21:05:57 UTC
-Juniper Networks, Inc. ex4500-40f internet router, kernel JUNOS 11.1R3.5 #0: 2011-06-25 01:18:46 UTC
-Juniper Networks, Inc. j2300 internet router, kernel JUNOS 8.5-20080528.0 #0: 2008-05-28 06:18:51 UTC
-Juniper Networks, Inc. j6300 internet router, kernel JUNOS 8.1R1.5 #0: 2006-11-02 00 Build date: 2006-11-02 00:27:54 UTC
-Juniper Networks, Inc. jsr2320 internet router, kernel JUNOS 9.2R1.10 #0: 2008-08-07 06:45:07 UTC
-Juniper Networks, Inc. m10 internet router, kernel JUNOS 7.6R3.6 #0: 2006-11-03 04 Build date: 2006-11-03 04:23:40 UTC
-Juniper Networks, Inc. m20 internet router, kernel JUNOS 6.3R2.2 #0: 2004-08-06 01 Build date: 2004-08-06 01:25:20 UTC
-Juniper Networks, Inc. m120 internet router, kernel JUNOS 10.0S14 #0: 2011-03-25 07:25:26 UTC
-Juniper Networks, Inc. mx480 internet router, kernel JUNOS 11.2R1.10 #0: 2011-07-29 07:15:34 UTC
-Juniper Networks, Inc. srx1400 internet router, kernel JUNOS 10.4R3.4 #0: 2011-03-19 22:06:23 UTC
-Juniper Networks, Inc. ERX-700 Edge Routing Switch SW Version : (11.1.0 release-0.0 [BuildId 12065]) Build Date : April 20, 2010 20:41 Copyright
-Juniper Networks, Inc. RX1400 Edge Switch Router SW Version : (10.3.2 patch-0.2 [BuildId 12841]) Build Date : February 3, 2011 16:26 Copyright
+EXTREME:
+ - ExtremeXOS version 12.0.3.16 v1203b16 by release-manager on Tue Apr 8 01:08:39 PDT 2008
+ - ExtremeWare X0S version 11.2.0.15 v1120b15 by release-manager on Fri Apr 1 18:40:23 PST 2005
+ - ExtremeXOS version 12.1.4.2 v1214b2 by release-manager on Wed Dec 9 13:32:31 PST 2009
+ - ExtremeXOS version 11.6.3.5 v1163b5 by release-manager on Sun Sep 9 10:46:16 PDT 2007
 
-MICROSENS G6 Switch
+FOUNDRY:
+ - Foundry Networks, Inc. Backbone, IronWare Version 06.6.36T41 Compiled on Jul 20 2001 at 21:38:29 labeled as BIS06636
+ - Foundry Networks, Inc. BigIron 15000 Router, IronWare Version 08.0.01vT53 Compiled on Feb 26 2010 at 20:07:21 labeled as B2P08001v
+ - Foundry Networks, Inc. BigIron MG8, IronWare Version V2.1.0bT103 Compiled on Apr 23 2005 at 13:32:29 labeled as V2.1.00b
+ - Foundry Networks, Inc. BigIron RX, IronWare Version V2.7.2mT143 Compiled on Apr 03 2012 at 19:38:35 labeled as V2.7.02m
+ - Foundry Networks, Inc. FES9604, IronWare Version 04.0.00Tc1 Compiled on Dec 18 2007 at 11:24:02 labeled as FEL04000
+ - Foundry Networks, Inc. FESX424HF-PREM, IronWare Version 04.3.00T3e3 Compiled on Nov 14 2008 at 15:23:55 labeled as SXR04300
+ - Foundry Networks, Inc. NetIron 800 Router, IronWare Version 08.0.01vT53 Compiled on Feb 26 2010 at 20:07:21 labeled as B2P08001v
+ - Foundry Networks, Inc. NetIron CES, IronWare Version V3.9.0T183 Compiled on Jul 23 2009 at 14:18:43 labeled as V3.9.00
 
-AX Series Advanced Traffic Manager AX1000, Advanced Core OS (ACOS) version 2.4.3-p6,
-AX Series Advanced Traffic Manager AX1000, Advanced Core OS (ACOS) version 2.2.4-p8,
-NetScaler NS9.0: Build 69.5, Date: Jun 12 2009, 06:00:53
-NetScaler NS9.1: Build 97.3.cl, Date: Aug 19 2009, 13:03:59
+HP:
+ - HP J4813A ProCurve Switch 2524, revision F.05.34, ROM F.02.01  (/sw/code/build/info(s02))
+ - HP J4121A ProCurve Switch 4000M, revision C.09.28, ROM C.06.01 (/sw/code/build/vgro(c09))
+ - ProCurve J4900B Switch 2626, revision H.08.98, ROM H.08.02 (/sw/code/build/fish(ts_08_5))
+ - HP J4900B ProCurve Switch 2626, revision H.08.69, ROM H.08.02 (/sw/code/build/fish(ts_08_5))
+ - ProCurve J9022A Switch 2810-48G, revision N.11.15, ROM N.10.01 (/sw/code/build/bass(bh2))
+ - ProCurve J9021A Switch 2810-24G, revision N.11.06, ROM N.10.01 (/sw/code/build/bass(bh2))
+ - ProCurve J9145A 2910al-24G Switch, revision W.14.03, ROM W.14.04 (/sw/code/build/sbm(t4a_RC3))
+ - HPJ3298A HP ProCurve Switch 212M, revision D.05.04, ROM D.05.01 (/sw/code/build/srao(f98))
+ - HP J9625A E2620-24-PoEP Switch, revision RA.15.05.0006, ROM RA.15.10 (/sw/code/build/xform(RA_15_05)) (Formerly ProCurve)
+ - ProCurve J8692A Switch 3500yl-24G, revision K.12.57, ROM K.12.12 (/sw/code/build/btm(t2g))
+ - HP J8692A Switch E3500yl-24G, revision K.15.05.0002, ROM K.15.13 (/sw/code/build/btm(K_15_05)) (Formerly ProCurve)
+ - HP Comware Platform Software, Software Version 5.20 Release 2208P01  HP A5120-24G EI Switch with 2 Interface Slots  Copyright (c) 2010-2011 Hewlett-Packard Development Company, L.P.
+ - HP Comware Platform Software, Software Version 5.20 Release 2208P01  HP A5120-48G EI Switch with 2 Interface Slots  Copyright (c) 2010-2011 Hewlett-Packard Development Company, L.P.  
+ - HP Comware Platform Software, Software Version 5.20.99 Release 2220P02  HP A5500-24G EI Switch with 2 Interface Slots  Copyright (c) 2010-2013 Hewlett-Packard Development Company, L.P. 
+ - HP Comware Platform Software, Software Version 5.20 Release 2208P01  HP A5500-24G-SFP EI Switch with 2 Interface Slots  Copyright (c) 2010-2011 Hewlett-Packard Development Company, L.P.
+
+JUNIPER:
+ - Juniper Networks, Inc. ex2200-24t-4g internet router, kernel JUNOS 10.2R1.8 #0: 2010-05-27 20:13:49 UTC
+ - Juniper Networks, Inc. ex2200-48t-4g internet router, kernel JUNOS 10.2R1.8 #0: 2010-05-27 20:13:49 UTC
+ - Juniper Networks, Inc. ex2200-c-12t-2g internet router, kernel JUNOS 11.3R1.7 #0: 2011-08-30 11:49:21 UTC
+ - Juniper Networks, Inc. ex3200-24p internet router, kernel JUNOS 11.1R3.5 #0: 2011-06-25 01:18:46 UTC
+ - Juniper Networks, Inc. ex4200-24f internet router, kernel JUNOS 10.0S1.1 #0: 2010-01-08 06:28:28 UTC
+ - Juniper Networks, Inc. ex4200-24t internet router, kernel JUNOS 10.2R1.8 #0: 2010-05-27 21:05:57 UTC
+ - Juniper Networks, Inc. ex4500-40f internet router, kernel JUNOS 11.1R3.5 #0: 2011-06-25 01:18:46 UTC
+ - Juniper Networks, Inc. j2300 internet router, kernel JUNOS 8.5-20080528.0 #0: 2008-05-28 06:18:51 UTC
+ - Juniper Networks, Inc. j6300 internet router, kernel JUNOS 8.1R1.5 #0: 2006-11-02 00 Build date: 2006-11-02 00:27:54 UTC
+ - Juniper Networks, Inc. jsr2320 internet router, kernel JUNOS 9.2R1.10 #0: 2008-08-07 06:45:07 UTC
+ - Juniper Networks, Inc. m10 internet router, kernel JUNOS 7.6R3.6 #0: 2006-11-03 04 Build date: 2006-11-03 04:23:40 UTC
+ - Juniper Networks, Inc. m20 internet router, kernel JUNOS 6.3R2.2 #0: 2004-08-06 01 Build date: 2004-08-06 01:25:20 UTC
+ - Juniper Networks, Inc. m120 internet router, kernel JUNOS 10.0S14 #0: 2011-03-25 07:25:26 UTC
+ - Juniper Networks, Inc. mx480 internet router, kernel JUNOS 11.2R1.10 #0: 2011-07-29 07:15:34 UTC
+ - Juniper Networks, Inc. srx1400 internet router, kernel JUNOS 10.4R3.4 #0: 2011-03-19 22:06:23 UTC
+ - Juniper Networks, Inc. ERX-700 Edge Routing Switch SW Version : (11.1.0 release-0.0 [BuildId 12065]) Build Date : April 20, 2010 20:41 Copyright
+ - Juniper Networks, Inc. RX1400 Edge Switch Router SW Version : (10.3.2 patch-0.2 [BuildId 12841]) Build Date : February 3, 2011 16:26 Copyright
+
+MICROSENS:
+ - MICROSENS G6 Switch
+
+NEXANS:
+ - GigaSwitch V3 TP SFP-I 48V ES3 (HW3/ENHANCED/SECURITY/V4.10C)
+ - GigaSwitch V3 TP SFP-I 48/54VDC ES3 (HW3/ENHANCED/SECURITY/V4.14W)
+ - GigaSwitch V3 TP(PSE+) SFP-I 48/54V ES3 (HW3/ENHANCED/SECURITY/V4.14W)
+ - GigaSwitch V5 TP(PSE+) SFP-2VI 54VDC (HW5-F40-P07-OFFICE-V5.01fn)